@REM */**********************************************************************\*
@REM **                                                                      **
@REM ** Licensed Materials - Property of IBM                                 **
@REM ** (C) Copyright IBM Corp. 2005, 2007  All Rights Reserved.             **
@REM **                                                                      **
@REM ** US Government Users Restricted Rights - Use, duplication, or         **
@REM ** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.    **
@REM **                                                                      **
@REM *\**********************************************************************/*
REM 
REM --------- Edit this script with the correct user and password 
REM
REM --------- This script deletes all history entries, which are older than 8 hours and for which newer data are available
REM --------- Using this approach the history datata will remain consistent.
REM --------- If a differnt timeschedule is used, edit the '8 hour' in the two insert and the delete statements below
REM


DB2 CONNECT TO 'ATLASDB' USER '' using ''

DB2 "SELECT COUNT(*) FROM HIST.CURRENTTAGS"
DB2 "SELECT COUNT(*) FROM HIST.TAG2ZONES"
DB2 "DECLARE GLOBAL TEMPORARY TABLE TEMP_TAG_DEL_DATA (TAGID VARCHAR(32),TAGTYPE CHARACTER(1), X_COORD DOUBLE, Y_COORD DOUBLE, Z_COORD DOUBLE, SPEED DOUBLE, YAW DOUBLE, PITCH DOUBLE, ROLL DOUBLE, BAT SMALLINT, CREDAT TIMESTAMP, TIME_IN_SEC BIGINT, TIME TIMESTAMP, VGRPID VARCHAR(64), HUBID INTEGER, IGNORECNT INTEGER, CLASSID INTEGER, ITEMID INTEGER, STATIONARY SMALLINT, ALERT CHARACTER(1), BUTTONS VARCHAR(16), ICONLINK VARCHAR(255), ICONLABEL VARCHAR(255), UPDATEINTERVAL INTEGER, VIRTUALZONE CHARACTER(1), CRUD CHARACTER(1), EXTENDED_ATTR VARCHAR(1024), CONTAINER SMALLINT, SEQUENCENO BIGINT) ON COMMIT PRESERVE ROWS NOT LOGGED WITH REPLACE IN ATLASTEMP"

DB2 "INSERT INTO SESSION.TEMP_TAG_DEL_DATA (SELECT * FROM HIST.CURRENTTAGS WHERE CRUD <> 'D' AND TIME IN (SELECT MAX(TIME) FROM HIST.CURRENTTAGS WHERE TIME < (CURRENT TIMESTAMP - 8 HOURS) GROUP BY TAGID) AND TIME < (CURRENT TIMESTAMP - 8 HOURS))"

DB2 "SELECT COUNT(*) FROM SESSION.TEMP_TAG_DEL_DATA"
DB2 "DELETE FROM HIST.CURRENTTAGS WHERE TIME < (CURRENT TIMESTAMP - 8 HOURS)"

DB2 "INSERT INTO HIST.CURRENTTAGS (SELECT * FROM SESSION.TEMP_TAG_DEL_DATA)"

DB2 COMMIT

DB2 "DECLARE GLOBAL TEMPORARY TABLE TEMP_TAG_DEL_DATA (CREDAT TIMESTAMP, TAGID VARCHAR(32), ZONEID INTEGER, TIME_IN_SEC BIGINT, CRUD CHARACTER(1)) ON COMMIT PRESERVE ROWS NOT LOGGED WITH REPLACE IN ATLASTEMP"

DB2 "INSERT INTO SESSION.TEMP_TAG_DEL_DATA (SELECT * FROM HIST.TAG2ZONES WHERE CRUD <> 'D' AND CREDAT IN (SELECT MAX(CREDAT) FROM HIST.TAG2ZONES WHERE CREDAT < (CURRENT TIMESTAMP - 8 HOURS) GROUP BY TAGID, ZONEID) AND CREDAT < (CURRENT TIMESTAMP - 8 HOURS))"

DB2 "SELECT COUNT(*) FROM SESSION.TEMP_TAG_DEL_DATA"
DB2 "DELETE FROM HIST.TAG2ZONES WHERE CREDAT < (CURRENT TIMESTAMP - 8 HOURS)"

DB2 "INSERT INTO HIST.TAG2ZONES (SELECT * FROM SESSION.TEMP_TAG_DEL_DATA)"

DB2 COMMIT

DB2 "SELECT COUNT(*) FROM HIST.AREAZONELIST"
DB2 "DELETE FROM HIST.AREAZONELIST WHERE ENTERDAT IS NOT NULL AND ENTERDAT < (CURRENT TIMESTAMP - 8 HOURS) AND LEAVEDAT IS NOT NULL"
DB2 "SELECT COUNT(*) FROM HIST.AREAZONELIST"

DB2 COMMIT

DB2 "SELECT COUNT(*) FROM HIST.CURRENTTAGS"
DB2 "SELECT COUNT(*) FROM HIST.TAG2ZONES"

DB2 CONNECT RESET

DB2 CONNECT TO 'EVENT' USER '' using ''

DB2 "SELECT COUNT(*) FROM CEI_T_EVENT00"
DB2 "DELETE FROM CEI_T_EVENT00  WHERE TIMESTAMP(CHAR (REPLACE (REPLACE (CREATION_TIME,'T','-'),':','.'),23)) <= (CURRENT_TIMESTAMP - 8 HOURS)"
DB2 "SELECT COUNT(*) FROM CEI_T_EVENT00"

DB2 COMMIT

DB2 CONNECT RESET
